version: "3.7"

services:
  vscode:
    build: .
    image: godevcontainer
    volumes:
      - ../:/workspace:cached
    # [Optional] Required for ptrace-based debuggers like C++, Go, and Rust
    cap_add:
      - SYS_PTRACE
    security_opt:
      - seccomp:unconfined
    # Overrides default command so things don't shut down after the process ends.
    command: /bin/sh -c "while sleep 1000; do :; done"
  jaeger:
    image: jaegertracing/all-in-one:latest
    ports:
    - "16686:16686"
  zipkin:
    image: ghcr.io/openzipkin/zipkin-slim:latest
    environment:
      - STORAGE_TYPE=mem
    ports:
      - 9411:9411
  nats-0:
    image: nats
    ports:
      - "8222:8222"
  nats-1:
    image: nats
    command: "--cluster nats://0.0.0.0:6222 --routes=nats-0://ruser:T0pS3cr3t@nats:6222"
    depends_on: ["nats-0"]
  nats-2:
    image: nats
    command: "--cluster nats://0.0.0.0:6222 --routes=nats-0://ruser:T0pS3cr3t@nats:6222"
    depends_on: ["nats-0"]
  zookeeper:
    image: confluentinc/cp-zookeeper:latest
    environment:
      ZOOKEEPER_CLIENT_PORT: 2181
      ZOOKEEPER_TICK_TIME: 2000
  kafka:
    image: confluentinc/cp-kafka:latest
    depends_on:
      - zookeeper
    environment:
      KAFKA_BROKER_ID: 1
      KAFKA_ZOOKEEPER_CONNECT: zookeeper:2181
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://kafka:9092
      KAFKA_LISTENER_SECURITY_PROTOCOL_MAP: PLAINTEXT:PLAINTEXT
      KAFKA_INTER_BROKER_LISTENER_NAME: PLAINTEXT
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
    
